#
# j00zek 2018 
#

from enigma import eTimer
from Components.config import config
from Components.Converter.Converter import Converter
from Components.Element import cached
from Components.FhromaSunCalculations import Sun

DBG = False
if DBG: from Components.FhromaComponents import j00zekDEBUG

Position = {}
        
class FhromaSun(Converter, object):
    UNKNOWN = 0
    SUNSET = 1
    SUNRISE = 2

    def __init__(self, arg):
        Converter.__init__(self, arg)
        if DBG: j00zekDEBUG('[j00zekSun:__init__] >>> arg="%s"' % arg)
        global TWISTED, Position
        if arg in ('wschod', 'sunset'):
            self.type = self.SUNRISE
        elif arg in ('zachod', 'sunrise'):
            self.type = self.SUNSET
        else:
            self.type = self.UNKNOWN
        try:
            config.plugins.WeatherPlugin.currEntry.addNotifier(self.setLocation, initial_call=True) 
        except Exception, e:
            if DBG: j00zekDEBUG("[j00zekSun:__init__] >>> Exception: '%s'" % str(e))

    def setLocation(self, configElement = None): 
        global Position
        if DBG: j00zekDEBUG("[j00zekSun:setLocation]")
        try:
            currEntry = int(config.plugins.WeatherPlugin.currEntry.value)
            Position['latitude'] = float(config.plugins.WeatherPlugin.Entry[currEntry].geolatitude.value)
            Position['longitude'] = float(config.plugins.WeatherPlugin.Entry[currEntry].geolongitude.value)
        except Exception, e:
            if DBG: j00zekDEBUG("[j00zekSun:setLocation] >>> Exception: '%s'" % str(e))
        if DBG: j00zekDEBUG("[j00zekSun:setLocation] latitude='%s' , longitude='%s'" % (Position['latitude'],Position['longitude']))
   
    @cached
    def getText(self):
        global Position
        try:
            if self.type == self.SUNSET:
                retTXT = str(sun.getSunsetTime(Position['longitude'], Position['latitude'] )['TZtime'])
            elif self.type == self.SUNRISE:
                retTXT = str(sun.getSunriseTime( Position['longitude'], Position['latitude'] )['TZtime'])
            else:
                retTXT = "---"
        except Exception:
                retTXT = "-?-"
        if DBG: j00zekDEBUG('[j00zekSun:getText] retTXT="%s"' % retTXT)
        return str(retTXT)

    text = property(getText)
    
sun = Sun()