# File: C (Python 2.7)

from Components.PerServiceDisplay import PerServiceBase
from enigma import iPlayableService
from Source import Source
from Components.Element import cached

class CurrentService(PerServiceBase, Source):
    
    def __init__(self, navcore):
        Source.__init__(self)
        PerServiceBase.__init__(self, navcore, {
            iPlayableService.evStart: self.serviceEvent,
            iPlayableService.evEnd: self.serviceEvent,
            iPlayableService.evUpdatedInfo: self.serviceEvent,
            iPlayableService.evUpdatedEventInfo: self.serviceEvent,
            iPlayableService.evCuesheetChanged: self.serviceEvent,
            iPlayableService.evVideoSizeChanged: self.serviceEvent }, with_event = True)
        self.navcore = navcore

    
    def serviceEvent(self, event):
        self.changed((self.CHANGED_SPECIFIC, event))

    
    def getCurrentService(self):
        return self.navcore.getCurrentService()

    getCurrentService = cached(getCurrentService)
    
    def getCurrentServiceReference(self):
        return self.navcore.getCurrentlyPlayingServiceReference()

    service = property(getCurrentService)
    
    def destroy(self):
        PerServiceBase.destroy(self)
        Source.destroy(self)


